package scheduler;

import scheduler.model.Medication;
import java.util.TreeMap;
import java.io.File;
import java.util.Scanner;

public abstract class MedTable {

	private static TreeMap<String, Medication> map = new TreeMap<String, Medication>();

	public static void addMedication(Medication m) {
		map.put(m.getName(), m);
	}

	public static void removeMedication(Medication m) {
		map.remove(m.getName());
	}

	public static void removeMedication(String name) {
		map.remove(name);
	}

	public static Medication getMedication(String name) {
		return map.get(name);
	}

	public static Medication getClosestMedication(String name) {
		if (map.tailMap(name).size() > 0) {
			String closest = map.tailMap(name).firstKey();
			if (closest.startsWith(name)) {
				return map.get(closest);
			}
		}
		return null;
		
	}

	public static void loadTable(File file) {
		Scanner scan;
		try {
			scan = new Scanner(file);
		} catch(java.io.FileNotFoundException e) {
			return;
		}
		while (scan.hasNext()) {
			if (scan.nextLine().startsWith("===")) {
				break;
			}
		}
		while (scan.hasNext()) {
			Scanner lineScan = new Scanner(scan.nextLine());
			Medication med = new Medication(lineScan.next());
			int attrInt = Integer.parseInt(lineScan.next());
			med.setColor(Medication.Color.getColorFromInt(attrInt));
			attrInt = Integer.parseInt(lineScan.next());
			med.setShape(Medication.Shape.getShapeFromInt(attrInt));
			attrInt = Integer.parseInt(lineScan.next());
			med.setSpecial1(Medication.Special.getSpecialFromInt(attrInt));
			attrInt = Integer.parseInt(lineScan.next());
			med.setSpecial2(Medication.Special.getSpecialFromInt(attrInt));
			addMedication(med);
		}		
	}

	public static void saveTable(File file) {
	
	}
}