package scheduler;

import scheduler.view.*;
import scheduler.model.*;
import javax.swing.*;
import java.awt.event.*;

public abstract class Scheduler {

	private static PatientPanel patientPanel;
	public static final String MED_FILE = "meds.txt";

	public static void main(String [] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch(Exception e) {}


		final JFrame frame = new JFrame();
		final Patient p = new Patient("");
		patientPanel = new PatientPanel(p);
		frame.add(patientPanel);

		MedTable.loadTable(new java.io.File(MED_FILE));

		// Frame Menu
		JMenuBar menuBar = new JMenuBar();
		JMenu fileMenu = new JMenu("File");

			JMenuItem newPatient = new JMenuItem("New Patient");
			newPatient.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					frame.setSize(340,399);
					frame.remove(patientPanel);
					patientPanel = new PatientPanel(new Patient(""));
					frame.add(patientPanel);
					frame.setSize(340,400);
				}
			});
			newPatient.setAccelerator(KeyStroke.getKeyStroke('N',InputEvent.CTRL_MASK));
			fileMenu.add(newPatient);

			fileMenu.addSeparator();

			JMenuItem loadPatient = new JMenuItem("Open...");
			loadPatient.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					frame.setSize(340,399);
					JFileChooser fc = new JFileChooser();
					// add a filter here.
					int ret = fc.showOpenDialog(frame);
					if (ret == JFileChooser.APPROVE_OPTION) {
						frame.remove(patientPanel);
						Patient p = PatientIO.loadPatientFile(fc.getSelectedFile());
						if (p != null) {
							patientPanel = new PatientPanel(p);
						}
						frame.add(patientPanel);
					}
					frame.setSize(340,400);
				}
			});
			loadPatient.setAccelerator(KeyStroke.getKeyStroke('O',InputEvent.CTRL_MASK));
			fileMenu.add(loadPatient);

			JMenuItem savePatient = new JMenuItem("Save...");
			savePatient.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					// add filter here.
					int ret = fc.showSaveDialog(frame);
					if (ret == JFileChooser.APPROVE_OPTION) {
						PatientIO.savePatientFile(fc.getSelectedFile());
					}
				}
			});
			savePatient.setAccelerator(KeyStroke.getKeyStroke('S',InputEvent.CTRL_MASK));
			fileMenu.add(savePatient);
					
			fileMenu.addSeparator();
		
			JMenuItem exitItem = new JMenuItem("Exit");
			exitItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					System.exit(0);
				}
			});
			exitItem.setAccelerator(KeyStroke.getKeyStroke('Q',InputEvent.CTRL_MASK));
			fileMenu.add(exitItem);
			

		menuBar.add(fileMenu);

		frame.setJMenuBar(menuBar);

		frame.pack();
		frame.setResizable(false);
		frame.setSize(340,400);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

}