package scheduler.model;


/**
 * A collection of bins making up a specific and regimented
 * scheduled described more thoroughly by each containing bin.
 */
public class Schedule {

	private Bin[] bins;

	/**
	 * Creates a new Schedule instance with the specified
	 * number of bins. Each bin is initialized to a new instance
	 * of {@link Bin}.
	 *
	 * @param numBins specifies the number of bins for this schedule
	 */
	public Schedule(int numBins) {
		this.bins = new Bin[numBins];
		for (int i = 0; i < numBins; i++) {
			bins[i] = new Bin();
		}
	}

	// Setter methods 

	/**
	 * Replaces the specified number bin with the bin argument. 
	 *
	 * @param bin the new bin to replace the old
	 * @param number specifies which bin should be replaced
	 */
	public void setBin(Bin bin, int number) {
		bins[number-1] = bin;
	}

	// Getter methods 

	/**
	 * Returns the bin corresponding to the number argument.
	 *
	 * @param number specifies which bin should be returned from the schedule.
	 */
	public Bin getBin(int number) {
		return bins[number-1];
	}

}